VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Variables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Variable"
Attribute VB_Ext_KEY = "Member0" ,"Variable"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private blnCalledFromReset As Boolean
Public Delimeter As String

Public Function Add(VarName As String, Value As Variant) As Variable
    'create a new object
    
    Dim objNewMember As Variable
    Set objNewMember = New Variable


    'set the properties passed into the method
    objNewMember.VarName = VarName
    If IsObject(Value) Then
        Set objNewMember.Value = Value
    Else
        objNewMember.Value = Value
    End If
        
    mCol.Add objNewMember, VarName



    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
    
    
End Function

Private Property Get Item(vntIndexKey As Variant) As Variable
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    Delimeter = Chr(156) & Chr(157) & Chr(156)
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

'      (. EvaluateString)
Public Function CommandLine() As String
    Dim Str As String, Var As Variable
    For Each Var In mCol
        With Var
            Str = Str & .VarName & "="
            Str = Str & .Value & Delimeter
        End With
    Next Var
    CommandLine = Str
End Function

'  (  ,    NewVars)
Public Sub Reset(Optional ByVal NewVars As String = "-")
    Dim l As Long
    
    For l = mCol.Count To 1 Step -1
        mCol.Remove l
    Next
    
    If NewVars = "-" Then Exit Sub
    blnCalledFromReset = True
    EvaluateString NewVars
End Sub

Public Property Get Var(ByVal VarName As String)
    If IsObject(Item(VarName).Value) Then
        Set Var = Item(VarName).Value
    Else
        Var = Item(VarName).Value
    End If
End Property

Public Property Let Var(ByVal VarName As String, NewValue)
    If IsObject(NewValue) Then
        Set Item(VarName) = NewValue
    Else
        Item(VarName) = NewValue
    End If
End Property

Public Function EvaluateString(ByVal Str As String, Optional ByVal WithReset As Boolean = True) As Long
    Dim strBuf As String
    Dim arrStrings() As String
    Dim arrVar() As String
    Dim l As Long
    strBuf = Str
    
    arrStrings = Split(strBuf, Delimeter)
    
    If WithReset Then
    If Not blnCalledFromReset Then
        Reset
        blnCalledFromReset = False
    End If
    End If
    
    For l = 0 To UBound(arrStrings) - 1
        arrVar = Split(arrStrings(l), "=", 2)
        Add arrVar(0), arrVar(1)
    Next l
    
End Function
